import "core-js/modules/es.symbol.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.object.get-own-property-descriptor.js";
import "core-js/modules/es.object.get-own-property-descriptors.js";
import "core-js/modules/es.object.keys.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.reflect.construct.js";
import "core-js/modules/web.dom-collections.for-each.js";
import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.function.name.js";
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import map from 'lodash/map';
import { getDefaultExample } from 'vue-inbrowser-compiler-utils';
import Styled from 'rsg-components/Styled';
import Markdown from 'rsg-components/Markdown';
import consts from '../../../scripts/consts';
import { DocumentedComponentContext } from '../VsgReactComponent/ReactComponent';
var styles = function styles(_ref) {
  var fontFamily = _ref.fontFamily,
    fontSize = _ref.fontSize,
    color = _ref.color;
  return {
    button: {
      padding: 0,
      fontSize: fontSize.base,
      fontFamily: fontFamily.base,
      textDecoration: 'underline',
      color: color.light,
      border: 0,
      cursor: 'pointer',
      background: 'transparent',
      '&:hover, &:active': {
        isolate: false,
        color: color.lightest
      }
    }
  };
};
export function propsToArray(props) {
  return map(props, function (prop, name) {
    return _objectSpread(_objectSpread({}, prop), {}, {
      name: name
    });
  });
}
export var ExamplePlaceholderRendererWithDoc = /*#__PURE__*/function (_Component) {
  function ExamplePlaceholderRendererWithDoc(props) {
    var _this;
    _classCallCheck(this, ExamplePlaceholderRendererWithDoc);
    _this = _callSuper(this, ExamplePlaceholderRendererWithDoc);
    _this.handleOpen = _this.handleOpen.bind(_this);
    var tags = props.component.props.tags;
    _this.state = {
      shouldDisplay: !tags || !tags.examples || !tags.examples.length || tags.examples[tags.examples.length - 1].content !== '[none]',
      isVisible: false
    };
    return _this;
  }
  _inherits(ExamplePlaceholderRendererWithDoc, _Component);
  return _createClass(ExamplePlaceholderRendererWithDoc, [{
    key: "handleOpen",
    value: function handleOpen() {
      this.setState({
        isVisible: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
        isVisible = _this$state.isVisible,
        shouldDisplay = _this$state.shouldDisplay;

      // in case we have an ignored example file
      // do not display the helper text
      if (!shouldDisplay) {
        return /*#__PURE__*/React.createElement("div", null);
      }
      var _this$props = this.props,
        classes = _this$props.classes,
        name = _this$props.name,
        props = _this$props.component.props;
      if (isVisible) {
        return /*#__PURE__*/React.createElement(Markdown, {
          text: "\nCreate **Readme.md** or **".concat(name, ".md** file in the component\u2019s folder like this:\n\n    ").concat(name, " example:\n\n    ```vue\n    ").concat(getDefaultExample(_objectSpread(_objectSpread({}, props), {}, {
            props: propsToArray(props.props),
            slots: propsToArray(props.slots),
            events: propsToArray(props.events)
          })), "\n    ```\n\nYou can also add examples and documentation in the `<docs>` block of your `.vue` Single File Component.\n\nYou may need to **restart** the style guide server after adding an example file.\n\nRead more in the [documenting components guide](").concat(consts.DOCS_DOCUMENTING, ").\n\t\t\t\t\t")
        });
      }
      return /*#__PURE__*/React.createElement("button", {
        className: classes.button,
        onClick: this.handleOpen
      }, "Add examples to this component");
    }
  }]);
}(Component);
_defineProperty(ExamplePlaceholderRendererWithDoc, "propTypes", {
  classes: PropTypes.object.isRequired,
  name: PropTypes.string,
  component: PropTypes.object
});
export function ExamplePlaceholderRenderer(props) {
  return /*#__PURE__*/React.createElement(DocumentedComponentContext.Consumer, null, function (component) {
    return /*#__PURE__*/React.createElement(ExamplePlaceholderRendererWithDoc, _extends({}, props, {
      component: component
    }));
  });
}
export default Styled(styles)(ExamplePlaceholderRenderer);