import "core-js/modules/es.symbol.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.object.get-own-property-descriptor.js";
import "core-js/modules/es.object.get-own-property-descriptors.js";
import "core-js/modules/es.object.keys.js";
import "core-js/modules/es.reflect.construct.js";
import "core-js/modules/web.dom-collections.for-each.js";
import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.promise.js";
import "core-js/modules/es.regexp.to-string.js";
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import PlaygroundError from 'rsg-components/PlaygroundError';
import Context from 'rsg-components/Context';
import { addScopedStyle } from 'vue-inbrowser-compiler-utils';
import { DocumentedComponentContext } from '../VsgReactComponent/ReactComponent';
import { RenderJsxContext, EnhanceAppContext } from '../../utils/renderStyleguide';
import { getCompiledExampleComponent } from './getCompiledExampleComponent';
import { getVueAppFactory } from './getVueApp';
var getVueApp = getVueAppFactory();
var PreviewAsync = /*#__PURE__*/function (_Component) {
  function PreviewAsync() {
    var _this;
    _classCallCheck(this, PreviewAsync);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, PreviewAsync, [].concat(args));
    _defineProperty(_this, "state", {
      error: null
    });
    _defineProperty(_this, "handleError", function (err) {
      _this.unmountPreview();
      _this.setState({
        error: err.toString()
      });
      console.error(err); // eslint-disable-line no-console
    });
    return _this;
  }
  _inherits(PreviewAsync, _Component);
  return _createClass(PreviewAsync, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // Clear console after hot reload, do not clear on the first load
      // to keep any warnings
      if (this.context.codeRevision > 0) {
        // eslint-disable-next-line no-console
        console.clear();
      }
      if (this.props.code.compiled) {
        this.setCompiledPreview(this.props.code.compiled);
      } else {
        this.executeCode(this.props.code.raw);
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.state.error !== nextState.error || this.props.code !== nextProps.code;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.code.raw !== prevProps.code.raw) {
        this.executeCode(this.props.code.raw);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unmountPreview();
    }
  }, {
    key: "unmountPreview",
    value: function unmountPreview() {
      this.destroyVueInstance();
      if (this.mountNode) {
        var _this$vueInstance, _this$vueInstance$unm;
        var el = this.mountNode.children[0];
        if (!el) {
          this.mountNode.innerHTML = ' ';
          this.mountNode.appendChild(document.createElement('div'));
          el = this.mountNode.children[0];
        }
        (_this$vueInstance = this.vueInstance) === null || _this$vueInstance === void 0 || (_this$vueInstance$unm = _this$vueInstance.unmount) === null || _this$vueInstance$unm === void 0 || _this$vueInstance$unm.call(_this$vueInstance);
        el = getVueApp({
          data: function data() {
            return {};
          },
          template: '<div></div>'
        }, el, function () {});
      }
    }
  }, {
    key: "destroyVueInstance",
    value: function destroyVueInstance() {
      if (this.vueInstance) {
        try {
          var _this$vueInstance$unm2, _this$vueInstance2, _this$vueInstance$$de, _this$vueInstance3;
          (_this$vueInstance$unm2 = (_this$vueInstance2 = this.vueInstance).unmount) === null || _this$vueInstance$unm2 === void 0 || _this$vueInstance$unm2.call(_this$vueInstance2);
          (_this$vueInstance$$de = (_this$vueInstance3 = this.vueInstance).$destroy) === null || _this$vueInstance$$de === void 0 || _this$vueInstance$$de.call(_this$vueInstance3);
        } catch (err) {
          // eat the error
        }
        this.vueInstance = null;
      }
    }
  }, {
    key: "executeCode",
    value: function executeCode(newCode) {
      var _this2 = this;
      import( /* webpackChunkName: "compiler" */'vue-inbrowser-compiler').then(function (opts) {
        _this2.setState({
          error: null
        });
        return opts;
      }).then(function (opts) {
        var moduleId = 'v-' + Math.floor(Math.random() * 1000) + 1;
        var compile = opts.compile;
        try {
          var example = compile(newCode, _objectSpread(_objectSpread(_objectSpread({}, _this2.context.config.compilerConfig), _this2.context.config.jsxInExamples ? {
            jsx: '__pragma__(h)',
            objectAssign: 'concatenate'
          } : {}), {}, {
            moduleId: moduleId
          }));
          _this2.setCompiledPreview(example, moduleId);
        } catch (err) {
          _this2.handleError(err);
        }
      });
    }
  }, {
    key: "setCompiledPreview",
    value: function setCompiledPreview(example, moduleId) {
      var _this3 = this;
      var _this$props = this.props,
        vuex = _this$props.vuex,
        component = _this$props.component,
        renderRootJsx = _this$props.renderRootJsx,
        enhancePreviewApp = _this$props.enhancePreviewApp;
      var el = this.mountNode.children[0];
      if (!el) {
        this.mountNode.innerHTML = ' ';
        this.mountNode.appendChild(document.createElement('div'));
        el = this.mountNode.children[0];
      }
      var _getCompiledExampleCo = getCompiledExampleComponent({
          compiledExample: example,
          evalInContext: this.props.evalInContext,
          vuex: vuex,
          component: component,
          renderRootJsx: renderRootJsx,
          enhancePreviewApp: enhancePreviewApp,
          destroyVueInstance: function destroyVueInstance() {
            return _this3.destroyVueInstance();
          },
          handleError: function handleError(e) {
            _this3.handleError(e);
          },
          el: el,
          locallyRegisterComponents: this.context.config.locallyRegisterComponents,
          moduleId: moduleId
        }),
        app = _getCompiledExampleCo.app,
        style = _getCompiledExampleCo.style;
      this.vueInstance = app;
      if (style) {
        addScopedStyle(style, moduleId);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;
      var error = this.state.error;
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
        ref: function ref(_ref) {
          return _this4.mountNode = _ref;
        }
      }, /*#__PURE__*/React.createElement("div", null)), error && /*#__PURE__*/React.createElement(PlaygroundError, {
        message: error
      }));
    }
  }]);
}(Component);
_defineProperty(PreviewAsync, "propTypes", {
  code: PropTypes.shape({
    raw: PropTypes.string.isRequired,
    compiled: PropTypes.oneOfType([PropTypes.shape({
      script: PropTypes.string,
      template: PropTypes.string,
      style: PropTypes.string
    }), PropTypes.bool])
  }).isRequired,
  evalInContext: PropTypes.func.isRequired,
  vuex: PropTypes.object,
  component: PropTypes.object,
  renderRootJsx: PropTypes.object,
  enhancePreviewApp: PropTypes.func.isRequired
});
_defineProperty(PreviewAsync, "contextType", Context);
export default function PreviewWithComponent(props) {
  return /*#__PURE__*/React.createElement(EnhanceAppContext.Consumer, null, function (enhancePreviewApp) {
    return /*#__PURE__*/React.createElement(RenderJsxContext.Consumer, null, function (renderRootJsx) {
      return /*#__PURE__*/React.createElement(DocumentedComponentContext.Consumer, null, function (component) {
        return /*#__PURE__*/React.createElement(PreviewAsync, _extends({}, props, {
          component: component,
          renderRootJsx: renderRootJsx,
          enhancePreviewApp: enhancePreviewApp
        }));
      });
    });
  });
}