import { createApp, Vue2, isVue3 } from 'vue-inbrowser-compiler-utils';
import { registerGlobalComponents } from '../../utils/globalComponents';
export function getVueAppFactory() {
  if (isVue3) {
    return function (component, el, enhancePreviewApp) {
      var app = createApp(component);
      enhancePreviewApp(app);
      registerGlobalComponents(app);
      app.mount(el);
      return app;
    };
  } else {
    return function (component, el) {
      var app = new Vue2(component);
      return app.$mount(el);
    };
  }
}