"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
var _vm = _interopRequireDefault(require("vm"));
var _path = _interopRequireDefault(require("path"));
var styleguideLoader = _interopRequireWildcard(require("./styleguide-loader"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
vi.mock('react-styleguidist/lib/loaders/utils/getComponentFilesFromSections', function () {
  return {
    "default": function _default() {
      return ['foo', 'bar'];
    }
  };
});
vi.mock('./utils/getSections', function () {
  return {
    "default": function _default() {
      return [];
    }
  };
});
describe('styleguide-loader', function () {
  var file = _path["default"].resolve(__dirname, '../../../../test/components/Button.vue');
  var configDir = _path["default"].resolve(__dirname, '../../../../test');
  it('should return valid, parsable JS', function () {
    var callback = function callback(err, result) {
      expect(result).toBeTruthy();
      expect(function () {
        return new _vm["default"].Script(result);
      }).not.toThrow();
    };
    styleguideLoader.pitch.call({
      async: function async() {
        return callback;
      },
      request: file,
      _styleguidist: {
        sections: [{
          components: 'components/**/*.js'
        }],
        configDir: configDir,
        getExampleFilename: function getExampleFilename() {
          return 'Readme.md';
        },
        getComponentPathLine: function getComponentPathLine(filepath) {
          return filepath;
        },
        theme: 'path/to/themeFile.js'
      },
      addDependency: function addDependency() {},
      addContextDependency: function addContextDependency() {}
    });
  });
  it('should add context dependencies to webpack from contextDependencies config option', function () {
    var callback = function callback() {
      expect(addContextDependency).toHaveBeenCalledTimes(2);
      expect(addContextDependency).toHaveBeenCalledWith(contextDependencies[0]);
      expect(addContextDependency).toHaveBeenCalledWith(contextDependencies[1]);
    };
    var contextDependencies = ['foo', 'bar'];
    var addContextDependency = vi.fn();
    styleguideLoader.pitch.call({
      async: function async() {
        return callback;
      },
      request: file,
      _styleguidist: {
        sections: [{
          components: 'components/**/*.js'
        }],
        configDir: configDir,
        getExampleFilename: function getExampleFilename() {
          return 'Readme.md';
        },
        getComponentPathLine: function getComponentPathLine(filepath) {
          return filepath;
        },
        contextDependencies: contextDependencies
      },
      addContextDependency: addContextDependency
    });
  });
});