"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getExamples;
var fs = _interopRequireWildcard(require("fs"));
var path = _interopRequireWildcard(require("path"));
var _qss = _interopRequireDefault(require("qss"));
var _requireIt = _interopRequireDefault(require("react-styleguidist/lib/loaders/utils/requireIt"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var examplesLoader = path.resolve(__dirname, '../examples-loader.js');

/**
 * Get require statement for examples file if it exists, or for default examples if it was defined.
 *
 * @param {string} file
 * @param {string} examplesFile
 * @param {string} displayName
 * @param {string} defaultExample
 * @param {boolean} isComponentDocInVueFile
 * @returns {object|Array}
 */
function getExamples(file, examplesFile, displayName, defaultExample, isComponentDocInVueFile) {
  var examplesFileToLoad = examplesFile || defaultExample;
  if (!examplesFileToLoad) {
    return null;
  }
  var relativePath = "./".concat(path.relative(path.dirname(examplesFileToLoad), file));
  var query = {
    displayName: displayName,
    file: relativePath,
    shouldShowDefaultExample: !examplesFile && !!defaultExample && !isComponentDocInVueFile,
    customLangs: 'vue|js|jsx|html'
  };
  if (examplesFile && fs.existsSync(examplesFile)) {
    return (0, _requireIt["default"])("!!".concat(examplesLoader, "?").concat(_qss["default"].encode(query), "!").concat(examplesFile));
  }
  if (defaultExample && !isComponentDocInVueFile) {
    return (0, _requireIt["default"])("!!".concat(examplesLoader, "?").concat(_qss["default"].encode(query), "!").concat(defaultExample));
  }
  return null;
}