"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
var docgen = _interopRequireWildcard(require("vue-docgen-api"));
var _getParser = _interopRequireDefault(require("./getParser"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
vi.mock('vue-docgen-api', function () {
  return {
    parse: vi.fn()
  };
});
describe('getParser', function () {
  var parseMock;
  beforeEach(function () {
    parseMock = vi.spyOn(docgen, 'parse');
    parseMock.mockReset();
  });
  it('should return the an enriched parser function', function () {
    var parserFunc = (0, _getParser["default"])({
      webpackConfig: {}
    });
    parserFunc('file1');
    expect(parseMock).toHaveBeenCalledWith('file1', {});
  });
  it('should return the default parser function', function () {
    var parserFunc = (0, _getParser["default"])({
      webpackConfig: {
        resolve: {
          modules: ['mod'],
          alias: {
            al: 'ias'
          }
        }
      }
    });
    parserFunc('file2');
    expect(parseMock).toHaveBeenCalledWith('file2', expect.objectContaining({
      modules: ['mod'],
      alias: {
        al: 'ias'
      }
    }));
  });
  it('should return options for pugParser', function () {
    var parserFunc = (0, _getParser["default"])({
      webpackConfig: {
        module: {
          rules: [{
            loader: 'pug-loader',
            options: {
              global: 'hello'
            }
          }]
        }
      }
    });
    parserFunc('file3');
    expect(parseMock).toHaveBeenCalledWith('file3', expect.objectContaining({
      pugOptions: {
        global: 'hello'
      }
    }));
  });
  it('should return options for pugParser in use arrays', function () {
    var parserFunc = (0, _getParser["default"])({
      webpackConfig: {
        module: {
          rules: [{
            use: [{
              loader: 'pug-loader',
              options: {
                global: 'hello'
              }
            }]
          }]
        }
      }
    });
    parserFunc('file4');
    expect(parseMock).toHaveBeenCalledWith('file4', expect.objectContaining({
      pugOptions: {
        global: 'hello'
      }
    }));
  });
});